/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { ScatterTriangulationSeries } from "./ScatterTriangulationSeries";
import { DependencyProperty } from "igniteui-react-core";
import { Point_$type, typeCast, Number_$type, fromEnum, runOn, delegateRemove, delegateCombine, markType, markDep } from "igniteui-react-core";
import { ValueBrushScale } from "./ValueBrushScale";
import { FastItemIntColumn } from "igniteui-react-core";
import { LinearContourValueResolver } from "./LinearContourValueResolver";
import { SeriesView } from "./SeriesView";
import { DataLegendSeriesValueInfo } from "igniteui-react-core";
import { DataLegendSeriesContext } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { IFastItemsSource_$type } from "igniteui-react-core";
import { ScalerParams } from "./ScalerParams";
import { ContourBuilder } from "./ContourBuilder";
import { Clipper } from "igniteui-react-core";
import { RectUtil } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { BrushUtil } from "igniteui-react-core";
import { BrushCollection } from "igniteui-react-core";
import { DataContext } from "igniteui-react-core";
import { Path } from "igniteui-react-core";
import { PropertyMetadata } from "igniteui-react-core";
import { boxArray$1 } from "igniteui-react-core";
import { isNaN_ } from "igniteui-react-core";
import { Pool$1 } from "igniteui-react-core";
import { PathGeometry } from "igniteui-react-core";
import { PathFigure } from "igniteui-react-core";
import { PolyLineSegment } from "igniteui-react-core";
import { PointCollectionUtil } from "igniteui-react-core";
import { Tuple$2 } from "igniteui-react-core";
import { GeometryUtil } from "igniteui-react-core";
import { stringIsNullOrEmpty } from "igniteui-react-core";
/**
 * @hidden
 */
export let ScatterContourSeries = /*@__PURE__*/ (() => {
    class ScatterContourSeries extends ScatterTriangulationSeries {
        get_ew() {
            return true;
        }
        constructor() {
            super();
            this.vz = null;
            this.vu = null;
            FastItemIntColumn.m();
            this.ab = ScatterContourSeries.$;
            this.vv = new LinearContourValueResolver();
        }
        ju(a, b) {
            let c = this.lv(b);
            if (c == ScatterContourSeries.$$p[4]) {
                return this.jv(a, b, this.v8);
            }
            return super.ju(a, b);
        }
        cg() {
            this.vw = new ScatterContourSeriesView(this);
            return this.vw;
        }
        get v0() {
            return this.vz;
        }
        set v0(a) {
            let b = this.v0 != a;
            if (b) {
                let c = this.v0;
                this.vz = a;
                this.raisePropertyChanged("ValueColumn", c, this.v0);
            }
        }
        getDataLegendSeriesContextAt(a, b) {
            let c = { $type: Point_$type, x: a, y: b };
            let d = this.jr(c);
            let e = d == null ? NaN : this.h1(d, "XMemberPath");
            let f = d == null ? NaN : this.h1(d, "YMemberPath");
            let g = d == null ? NaN : this.h1(d, "ValueMemberPath");
            let h = new DataLegendSeriesValueInfo();
            h.a = 13;
            h.l = e;
            h.p = "X";
            h.q = this.u3 != null ? this.u3 : "X";
            h.r = this.uz != null ? this.uz : "X:";
            h.s = this.u1 != null ? this.u1 : "";
            let i = new DataLegendSeriesValueInfo();
            i.a = 14;
            i.l = f;
            i.p = "Y";
            i.q = this.vb != null ? this.vb : "Y";
            i.r = this.u7 != null ? this.u7 : "Y:";
            i.s = this.u9 != null ? this.u9 : "";
            let j = new DataLegendSeriesValueInfo();
            j.a = 0;
            j.l = g;
            j.p = "Value";
            j.q = this.v8 != null ? this.v8 : "Value";
            j.r = this.v4 != null ? this.v4 : "V:";
            j.s = this.v6 != null ? this.v6 : "";
            let k = new DataLegendSeriesContext();
            k.f = ((() => {
                let $ret = new List$1(DataLegendSeriesValueInfo.$, 0);
                $ret.add(h);
                $ret.add(i);
                $ret.add(j);
                return $ret;
            })());
            k.b = this.aw();
            return k;
        }
        o8(a, b, c, d) {
            super.o8(a, b, c, d);
            switch (b) {
                case "FastItemsSource":
                    let e = typeCast(IFastItemsSource_$type, c);
                    if (e != null) {
                        e.deregisterColumn(this.v0);
                        this.v0 = null;
                    }
                    let f = typeCast(IFastItemsSource_$type, d);
                    if (f != null) {
                        this.v0 = this.c3(this.v8);
                    }
                    this.pp(this.fq && c != null);
                    break;
                case ScatterContourSeries.$$p[4]:
                    if (this.c6 != null) {
                        this.c6.deregisterColumn(this.v0);
                        this.v0 = this.c3(this.v8);
                    }
                    this.pp(false);
                    this.ol();
                    break;
                case "ValueResolver":
                    this.pp(false);
                    this.ol();
                    break;
                case ScatterContourSeries.$$p[1]:
                    let g = c;
                    let h = d;
                    if (g != null) {
                        g.unregisterSeries(this);
                    }
                    if (h != null) {
                        h.registerSeries(this);
                    }
                    this.wc();
                    this.pp(false);
                    this.ol();
                    break;
                case "ActualBrush":
                    this.wc();
                    this.pp(false);
                    this.ol();
                    break;
            }
        }
        nj(a, b) {
            super.nj(a, b);
            if (a) {
                b.b6(a);
            }
        }
        pq(a) {
            super.pq(a);
            this.wb(this.cj);
        }
        po(a, b, c, d, e) {
            super.po(a, b, c, d, e);
            let f = this.a7.a$h.item(d);
            f.a3(c);
            if (this.dl(f)) {
                return;
            }
            this.wb(f);
        }
        wb(a) {
            if (this.dl(a)) {
                return;
            }
            let b;
            let c;
            let d = a;
            let e = a.getViewInfo(c, b);
            c = e.p0;
            b = e.p1;
            let f = new ScalerParams(1, b, c, this.t1.ch);
            f.c = this.getEffectiveViewport1(a);
            let g = new ScalerParams(1, b, c, this.t2.ch);
            g.c = this.getEffectiveViewport1(a);
            let h = this.t1;
            let i = this.t2;
            let j = this.ub.count;
            let k;
            let xArr_ = this.ue.asArray();
            k = (xArr_.slice(0));
            let l;
            let yArr_ = this.uf.asArray();
            l = (yArr_.slice(0));
            let m = this.v0.asArray();
            let n = this.ub.asArray();
            let o = this.uc.asArray();
            let p = this.ud.asArray();
            let q = this.vv.j(this.v0);
            let r = new List$1(Number_$type, 1, q).toArray();
            h.hn(boxArray$1(k), 0, k.length, f);
            i.hn(boxArray$1(l), 0, l.length, g);
            let s = r.length;
            let t = new Array(s);
            for (let u = 0; u < s; ++u) {
                t[u] = new ContourBuilder();
            }
            let v = c.top;
            let w = c.left;
            let x = c.right;
            let y = c.bottom;
            let z;
            let aa;
            let ab;
            let ac;
            let ad = k.length;
            for (let ae = 0; ae < j; ae++) {
                let af = n[ae];
                let ag = o[ae];
                let ah = p[ae];
                if ((af >= ad) || (ag >= ad) || (ah >= ad) || (af < 0) || (ag < 0) || (ah < 0)) {
                    continue;
                }
                let ai = k[af];
                let aj = l[af];
                let ak = { $type: Point_$type, x: ai, y: aj };
                let al = k[ag];
                let am = l[ag];
                let an = { $type: Point_$type, x: al, y: am };
                let ao = k[ah];
                let ap = l[ah];
                let aq = { $type: Point_$type, x: ao, y: ap };
                z = an.y < aq.y ? an.y : aq.y;
                z = ak.y < z ? ak.y : z;
                aa = an.y > aq.y ? an.y : aq.y;
                aa = ak.y > aa ? ak.y : aa;
                ab = an.x < aq.x ? an.x : aq.x;
                ab = ak.x < ab ? ak.x : ab;
                ac = an.x > aq.x ? an.x : aq.x;
                ac = ak.x > ac ? ak.x : ac;
                if (z < y && aa > v && ab < x && ac > w) {
                    let ar = m[af];
                    let as = m[ag];
                    let at = m[ah];
                    if (isNaN_(ar) || isNaN_(as) || isNaN_(at)) {
                        continue;
                    }
                    for (let au = 0; au < s; au++) {
                        let av = r[au];
                        let aw = t[au];
                        switch ((ar < av ? 1 : 0) | (as < av ? 2 : 0) | (at < av ? 4 : 0)) {
                            case 0: break;
                            case 1:
                                aw.d(aw.k(af, ak.x, ak.y, ar, ag, an.x, an.y, as, av), aw.k(ah, aq.x, aq.y, at, af, ak.x, ak.y, ar, av));
                                break;
                            case 2:
                                aw.d(aw.k(ag, an.x, an.y, as, ah, aq.x, aq.y, at, av), aw.k(af, ak.x, ak.y, ar, ag, an.x, an.y, as, av));
                                break;
                            case 3:
                                aw.d(aw.k(ag, an.x, an.y, as, ah, aq.x, aq.y, at, av), aw.k(ah, aq.x, aq.y, at, af, ak.x, ak.y, ar, av));
                                break;
                            case 4:
                                aw.d(aw.k(ah, aq.x, aq.y, at, af, ak.x, ak.y, ar, av), aw.k(ag, an.x, an.y, as, ah, aq.x, aq.y, at, av));
                                break;
                            case 5:
                                aw.d(aw.k(af, ak.x, ak.y, ar, ag, an.x, an.y, as, av), aw.k(ag, an.x, an.y, as, ah, aq.x, aq.y, at, av));
                                break;
                            case 6:
                                aw.d(aw.k(ah, aq.x, aq.y, at, af, ak.x, ak.y, ar, av), aw.k(af, ak.x, ak.y, ar, ag, an.x, an.y, as, av));
                                break;
                            case 7: break;
                        }
                    }
                }
            }
            let ax = new Clipper(0, RectUtil.r(c, 2), false);
            let ay = new List$1(List$1.$.specialize(List$1.$.specialize(Point_$type)), 0);
            for (let az = 0; az < s; ++az) {
                let a0 = t[az];
                let a1 = new List$1(List$1.$.specialize(Point_$type), 0);
                let a2 = a0.c();
                for (let a3 = 0; a3 < a2.count; a3++) {
                    let a4 = a2._inner[a3];
                    let a5 = new List$1(Point_$type, 0);
                    ax.i = a5;
                    for (let a6 of fromEnum(a4)) {
                        ax.j({ $type: Point_$type, x: a0.g.item(a6), y: a0.h.item(a6) });
                    }
                    ax.i = null;
                    a1.add(a5);
                }
                ay.add(a1);
            }
            d.b5(ay, r);
        }
        qd() {
            super.qd();
            this.wc();
        }
        wc() {
            let a = this.ss;
            if (a == null) {
                a = this.sw;
            }
            if (a == null) {
                a = BrushUtil.h(255, 255, 255, 255);
            }
            let b = new ValueBrushScale();
            b.brushes = new BrushCollection();
            if (this.vy == null || this.vy.brushes == null || this.vy.brushes.count == 0) {
                b.brushes.add(BrushUtil.m(a, -0.5));
                b.brushes.add(a);
            }
            else {
                for (let c of fromEnum(this.vy.brushes)) {
                    b.brushes.add(c);
                }
            }
            if (this.vy != null) {
                if (!isNaN_(this.vy.minimumValue)) {
                    b.minimumValue = this.vy.minimumValue;
                }
                if (!isNaN_(this.vy.maximumValue)) {
                    b.maximumValue = this.vy.maximumValue;
                }
                b.logarithmBase = this.vy.logarithmBase;
                b.isLogarithmic = this.vy.isLogarithmic;
            }
            this.vx = b;
        }
        get vv() {
            return this.vu;
        }
        set vv(a) {
            let b = a != this.vv;
            if (b) {
                if (this.vu != null) {
                    let c = this.vu;
                    c.updated = delegateRemove(c.updated, runOn(this, this.wd));
                }
                let d = this.vu;
                this.vu = a;
                if (this.vu != null) {
                    let e = this.vu;
                    e.updated = delegateCombine(e.updated, runOn(this, this.wd));
                }
                this.raisePropertyChanged("ValueResolver", d, a);
                this.pp(false);
            }
        }
        wd(a, b) {
            this.pp(false);
        }
        gl(a, b, c) {
            return super.gl(a, b, c) && this.vv != null && this.ue != null && this.uf != null && this.ub != null && this.uc != null && this.ud != null && this.ue.count > 0 && this.uf.count > 0 && this.ub.count > 0 && this.uc.count > 0 && this.ud.count > 0;
        }
        au(a, b) {
            let c = this.vw.ca(a, b);
            if (c != null) {
                return c.dataContext;
            }
            return null;
        }
    }
    ScatterContourSeries.$t = /*@__PURE__*/ markType(ScatterContourSeries, 'ScatterContourSeries', ScatterTriangulationSeries.$);
    ScatterContourSeries.$$p = /*@__PURE__*/ markDep(DependencyProperty, PropertyMetadata, ScatterContourSeries, 'raisePropertyChanged', ['ActualFillScale:vx:we', [ValueBrushScale.$, null], 'FillScale:vy:wf', [ValueBrushScale.$, null], 'ValueMemberAsLegendLabel:v4:wg', [2, null], 'ValueMemberAsLegendUnit:v6:wh', [2, null], 'ValueMemberPath:v8:wi', [2, null]]);
    return ScatterContourSeries;
})();
/**
 * @hidden
 */
export let ScatterContourSeriesView = /*@__PURE__*/ (() => {
    class ScatterContourSeriesView extends SeriesView {
        constructor(a) {
            super(a);
            this.b2 = null;
            this.b1 = null;
            this.b4 = null;
            this.b3 = new List$1(Brush.$, 0);
            this.b0 = null;
            this.b4 = new List$1(Path.$, 0);
            this.b1 = a;
            this.b2 = ((() => {
                let $ret = new Pool$1(Path.$);
                $ret.create = runOn(this, this.cb);
                $ret.destroy = runOn(this, this.b9);
                $ret.activate = runOn(this, this.b7);
                $ret.disactivate = runOn(this, this.b8);
                return $ret;
            })());
        }
        cb() {
            let a = new Path();
            a.dataContext = ((() => {
                let $ret = new DataContext();
                $ret.series = this.e;
                return $ret;
            })());
            this.b4.add(a);
            return a;
        }
        b7(a) {
            a._visibility = 0;
        }
        b8(a) {
            a._visibility = 1;
        }
        b9(a) {
            this.b4.remove(a);
        }
        b5(a, b) {
            let c = 0;
            this.b0 = b;
            this.b3.clear();
            let d = this.b1.vx;
            for (let e = 0; e < b.length; e++) {
                let f = b[e];
                let g = a._inner[c];
                let h = new PathGeometry();
                for (let i = 0; i < g.count; i++) {
                    let j = g._inner[i];
                    if (j.count == 0) {
                        continue;
                    }
                    let k = PointCollectionUtil.f(j);
                    let l = ((() => {
                        let $ret = new PathFigure();
                        $ret.isClosed = false;
                        $ret.isFilled = false;
                        $ret.startPoint = k._inner[0];
                        return $ret;
                    })());
                    l._segments.add(((() => {
                        let $ret = new PolyLineSegment();
                        $ret.points = k;
                        return $ret;
                    })()));
                    h.c.add(l);
                }
                this.b2.item(c).an = h;
                if (this.b2.item(c).dataContext != null) {
                    this.b2.item(c).dataContext.item = f;
                }
                if (d != null) {
                    let m = d.getBrushByValue(f, this.b1.v0);
                    if (m == null) {
                        m = this.e.ss;
                    }
                    this.b3.add(m);
                }
                else {
                    this.b3.add(this.e.ss);
                }
                c++;
            }
            this.b2.count = c;
            this.as();
        }
        bg(a, b) {
            super.bg(a, b);
            let c = a;
            c._stroke = this.b3._inner[b];
            c.ad = this.e.hk;
            if (c.y != null) {
                this.k.j(c, c.y);
            }
        }
        bh(a, b) {
            super.bh(a, b);
            let c = a;
            let d = this.bs(b);
            c._stroke = d;
            c.ad = this.e.hk + 3;
        }
        a8(a, b) {
            super.a8(a, b);
            for (let c = 0; c < this.b4.count; c++) {
                let d = this.b4._inner[c];
                if (d._visibility != 1) {
                    this.bf(d, c, b);
                    a.t(d);
                }
            }
        }
        b6(a) {
            this.b2.count = 0;
            this.as();
        }
        an(a) {
            super.an(a);
            let b = new List$1(Tuple$2.$.specialize(Number_$type, Path.$), 0);
            if (this.b0 != null) {
                for (let c = 0; c < this.b2.count; c++) {
                    b.add(new Tuple$2(Number_$type, Path.$, this.b0[c], this.b2.item(c)));
                }
            }
            b.aa((d, e) => {
                if (d.c < e.c) {
                    return -1;
                }
                else if (d.c > e.c) {
                    return 1;
                }
                return 0;
            });
            for (let d = 0; d < b.count; d++) {
                let e = typeCast(Path.$, b._inner[d].d);
                if (e._visibility != 1) {
                    this.e.a9.exportPathData(a, e, "contour" + d, ["Main "]);
                }
            }
        }
        getDefaultTooltipTemplate() {
            let a = "<div class='ui-chart-default-tooltip-content'><span";
            let b = this.e.a7.a$r(this.e);
            if (!stringIsNullOrEmpty(b)) {
                a += " style='color:" + b + "'";
            }
            a += ">" + this.b1.title + "</span><br/>";
            if (!stringIsNullOrEmpty(this.b1.v8)) {
                a += "<span>Value: ${item}</span>";
            }
            a += "</div>";
            return a;
        }
        ca(a, b) {
            for (let c = 0; c < this.b4.count; c++) {
                let d = this.b4._inner[c];
                let e = typeCast(PathGeometry.$, d.an);
                if (e != null) {
                    for (let f = 0; f < e.c.count; f++) {
                        let g = e.c._inner[f];
                        let h = e.c._inner[f]._startPoint;
                        for (let i = 0; i < g._segments.count; i++) {
                            let j = typeCast(PolyLineSegment.$, g._segments._inner[i]);
                            if (j != null) {
                                let k = this.b1.hk / 2 + this.b1.hy(b);
                                if (j._points.count > 0 && GeometryUtil.b(a, h, j._points, k)) {
                                    return d;
                                }
                            }
                        }
                    }
                }
            }
            return null;
        }
    }
    ScatterContourSeriesView.$t = /*@__PURE__*/ markType(ScatterContourSeriesView, 'ScatterContourSeriesView', SeriesView.$);
    return ScatterContourSeriesView;
})();
